#!/bin/bash

function my_cmd(){
    local ppid=$$
    local pid=$BASHPID
    local gpu_id=$1
    export CUDA_VISIBLE_DEVICES=${gpu_id}
    echo "ppid: ${ppid}, pid: ${pid}, gpu_id: ${gpu_id}, begin sleep 10 s"
    sleep 10
    echo "ppid: ${ppid}, pid: ${pid}, gpu_id: ${gpu_id} sleep 10 s done."
    # 当进程结束以后，再向fd6中加上一个回车符，即补上了read -u6减去的那个
    echo ${gpu_id} >&6
}

tmp_fifofile="/tmp/$$.fifo"
# 新建一个fifo类型的文件
mkfifo $tmp_fifofile
# 将fd6指向fifo类型
exec 6<>$tmp_fifofile
# rm $tmp_fifofile

# 最大可同时执行线程数量
thread_num=5
# 任务总数
job_num=100

# 根据线程总数量设置令牌个数
for ((i=0;i<${thread_num};i++));do
    echo ${i}
done >&6

for ((i=0;i<${job_num};i++));do # 任务数量
    # 一个read -u6命令执行一次，就从fd6中减去一个回车符，然后向下执行，
    # fd6中没有回车符的时候，就停在这了，从而实现了线程数量控制
    read -u6 gpu_id

    #可以把具体的需要执行的命令封装成一个函数
    {
        my_cmd ${gpu_id}
    } &
done

wait
# 关闭fd6
exec 6>&-
echo "over"
